#!/usr/bin/env python3
#
# SPDX-FileCopyrightText: 2025 Carlos M. Fonseca <cmfonsec@dei.uc.pt>
#
# SPDX-License-Identifier: Apache-2.0


from api.base import Neighbourhood, Move
import math
from api.utils import sparse_fisher_yates_iter


# ------------------------------- Neighbourhood ------------------------------

class TwoOptNeighbourhood(Neighbourhood):
    def moves(self, solution):
        assert self.problem == solution.problem
        raise NotImplementedError("Not implemented yet")

    def random_moves_without_replacement(self, solution):
        assert self.problem == solution.problem
        # The Fisher-Yates shuffle algorithm is used to generate a random
        # permutation of the integers 0, 1, ..., n*(n-3)/2 - 1. The
        # resulting integers are then mapped to pairs (i, j) of indices
        # representing the 2-opt moves. The algorithm is efficient and
        # generates a uniform distribution of moves.
        raise NotImplementedError("Not implemented yet")
        if solution.is_feasible():
            # Sample integers at random and convert them into moves. To that
            # end, start by mapping x = 0, 1, ..., onto pairs (a, b) as shown
            # in the following table:
            #
            #    b  0   1   2   3   4   5
            #  a +------------------------
            #  0 |  -   -   -   -   -   -
            #  1 |  0   -   -   -   -   -
            #  2 |  1   2   -   -   -   -
            #  3 |  3   4   5   -   -   -
            #  4 |  6   7   8   9   -   -
            #  5 | 10  11  12  13  14   -
            #  6 | 15   …   …   …   …   …
            #
            # Note how x = a*(a-1)/2 + b.
            # To solve for a given x, rewrite the expression as
            # a**2 - a + 2*b - 2*x = 0, which has one positive root:
            # a = (1 + sqrt(1 + 8*x - 8*b) / 2
            # Taking a = floor((1 + sqrt(1 + 8*x)) / 2) and
            # b = x - a*(a-1)/2 allows both the desired jx = a + 2 and
            # ix = b + 1 to be obtained.
            # Note: since pair (1, n) would not be a valid 2-opt move, it can
            # be skipped or simply replaced by (n-2, n) when generated, which
            # saves one iteration.
           



# ----------------------------------- Move -----------------------------------

class TwoOptMove(Move):
    def __init__(self, neighbourhood, ix, jx):
        self.neighbourhood = neighbourhood
        # ix and jx are indices
        self.ix = ix
        self.jx = jx

    def __str__(self):
        return "%d:%d" % (self.i, self.j)

    def apply(self, solution):
        prob = solution.problem
        # Update tour length
        # Update solution
        raise NotImplementedError("Not implemented yet")

    def objective_value_increment(self,  solution):
        prob = solution.problem
        # Tour length increment
        raise NotImplementedError("Not implemented yet")
        return incr

