#!/usr/bin/env python3
#
# SPDX-FileCopyrightText: 2025 Carlos M. Fonseca <cmfonsec@dei.uc.pt>
#
# SPDX-License-Identifier: Apache-2.0



class Solution:
    def __init__(self, problem, tour, not_visited, lb):
        self.problem = problem
        self.tour = tour
        self.not_visited = not_visited
        self.lb = lb

    def __str__(self):
        return " ".join(map(str, self.tour))

    def copy(self):
        return self.__class__(self.problem,
            self.tour.copy(),
            self.not_visited.copy(),
            self.lb)

    def problem_instance(self):
        return self.problem

    def is_feasible(self):
        return len(self.not_visited) == 0

    def objective_value(self):
        if self.is_feasible():
            return self.lb

    def lower_bound(self):
        return self.lb
